<?php

class Horde_DAV_ApplicationCollection extends Sabre_DAV_Directory {

    protected $appName;
    protected $basePath;

    function __construct($appName, $basePath = '') {

        $this->appName = $appName;
        $this->basePath = $basePath;

    }

    function getName() {

        if ($this->basePath) return basename($this->basePath);
        return $this->appName; 

    }

    function getChildren() {

        global $registry;

        $children = array();

        $items = $registry->callByPackage($this->appName,'browse', array('path' => $this->appName . '/' . $this->basePath, 'depth' => 0));
        foreach($items as $fullPath=>$item) {

            list($appName,$basePath) = explode('/',$fullPath,2);
            if (isset($item['browseable']) && $item['browseable']) {
                $children[] = new Horde_DAV_ApplicationCollection($this->appName,$basePath);
            } else {
                $children[] = new Horde_DAV_ApplicationFile($this->appName,$basePath);
            }

        }

        return $children;

    }

    function createChild($name,$stream) {

        global $registry;
        $registry->callByPackage($this->appName,'put',array('path'=>$this->basePath . '/' . $name,'content'=>stream_get_contents($stream)));

    }

    function createDirectory($name) {

        global $registry;
        $registry->callByPackage($this->appName,'mkcol',array('path'=>$this->basePath . '/' . $name));

    }

    function delete() {
        
        global $registry;
        $registry->callByPackage($this->appName,'path_delete',array($this->basePath));

    }

}
