<?php

class Horde_DAV_ApplicationFile extends Sabre_DAV_File {

    protected $appName;
    protected $basePath;

    protected $data;
    protected $contentType;
    protected $modified;

    function __construct($appName, $basePath = '') {

        $this->appName = $appName;
        $this->basePath = $basePath;

        global $registry;
        $items = $registry->callByPackage($this->appName, 'browse', array('path' => $this->basePath, 'properties' => array()));
        $this->data = $items['data'];
        $this->contentType = $items['mimetype'];
        $this->modified = $items['mtime'];

    }

    function getName() {

        if ($this->basePath) return basename($this->basePath);
        return $this->appName; 

    }

    function get() {

        $stream = fopen('php://temp','r+');
        fwrite($stream,$this->data);
        rewind($stream);
        return $stream;

    }

    function put($stream) {

        global $registry;
        $registry->callByPackage($this->appName,'put',array('path'=>$this->basePath,'content'=>stream_get_contents($stream)));

    }

    function delete() {
        
        global $registry;
        $registry->callByPackage($this->appName,'path_delete',array($this->basePath));

    }

    function getSize() {

        return strlen($this->data);

    }

    function getContentType() {

        return 'text/plain';
        return $this->contentType;

    }

    function getLastModified() {
        
        return $this->modified;

    }

}
