<?php

class Horde_DAV_RootNode extends Sabre_DAV_Directory {

    public function getName() {

        return 'horde'; 

    }

    public function getChildren() {

        global $registry;

        $apps = $registry->listApps(null, false, PERMS_READ);

        $children = array();

        foreach($apps as $appName) {

            if ($this->checkAppSupported($appName))
                $children[] = new Horde_DAV_ApplicationCollection($appName);

        }

        return $children;

    }

    public function getChild($name) {

        if ($this->checkAppSupported($name)) {
            return new Horde_DAV_ApplicationCollection($name);
        }
        throw new Sabre_DAV_Exception_FileNotFound('Application with name: ' . $name . ' was not found');

    }

    protected function checkAppSupported($appName) {

        global $registry;

        try {

            // Support for browse metod
            if (!$registry->hasMethod('browse', $appName)) return false; 

            // Checking for child-objects
            $result = $registry->callByPackage($appName, 'browse', array('path' => '/', 'depth' => 0));

            // If an empty array or false was returned from the app, we also return false
            if (!$result) return false;

            return true;

        } catch (Horde_Exception $e) {

            // Silently failing
            return false;

        }

    }

}
