<?php

include 'Sabre.includes.php';

class Horde_DAV_Server {

    const AUTH_REALM = 'Horde WebDAV';

    protected $server;

    function __construct() {

        global $registry;

        $root = new Horde_DAV_RootNode();
        $tree = new Sabre_DAV_ObjectTree($root);
        $this->server = new Sabre_DAV_Server($tree);

        // PHP messages destroy XML output -> switch them off
        //ini_set('display_errors', 0);

        // The base url is determined based on the horde webroot
        $this->server->setBaseUri($registry->applications['horde']['webroot'] . '/dav.php/');

        // Adding browser plugin for easy debugging
        $this->server->addPlugin(new Sabre_DAV_Browser_Plugin());
        
    }

    function exec() {

        if (!$this->authenticate()) return false;
        $this->server->exec();

    }

    function authenticate() {

        // note: this authentication system is only temporary
        // we need to switch to the auth plugin later for caldav
        // compatibility. Currently we are unable to do this, because the 
        // authentication plugin system only supports Digest.

        $auth = new Sabre_HTTP_BasicAuth();
        $auth->setRealm(self::AUTH_REALM);
        
        $up = $auth->getUserPass();
        if (!$up) { 
            $auth->requireLogin();
            return false;
        }

        $hordeAuth = Horde_Auth::singleton($GLOBALS['conf']['auth']['driver']);
        if (!$hordeAuth->authenticate($up[0],array('password'=>$up[1]))) {
            $auth->requireLogin();
            return false;
        }

        return true;


    }


}
